package gssim.gssimstudio.flex.app.editor;

import java.io.Serializable;
import org.vinetoolkit.grms3client.GRMS3Job;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import gssim.db.dao.data.Allocation;
import gssim.db.dao.data.AllocationDetails;
import gssim.db.dao.data.BlobProperty;
import gssim.db.dao.data.Configuration;
import gssim.db.dao.data.Metaexperiment;
import gssim.db.dao.data.Experiment;
import gssim.db.dao.data.ExperimentStats;
import gssim.db.dao.data.Queues;
import gssim.db.dao.data.Plugin;
import gssim.db.dao.data.Reservation;
import gssim.db.dao.data.ReservationDetails;
import gssim.db.dao.data.Resource;
import gssim.db.dao.data.ResourceAllTimeline;
import gssim.db.dao.data.ResourceEnTimeline;
import gssim.db.dao.data.Task;
import gssim.db.dao.data.TextProperty;
import gssim.db.dao.data.Unit;
import gssim.db.dao.data.UnitAllTimeline;
import gssim.db.dao.data.UnitDetails;
import gssim.db.dao.data.UnitEnTimeline;
import gssim.db.dao.data.User;

/*
 * @author Mateusz Ciche�ski, Jarek Szymczak
 */
public class GSSimStudioModel implements Serializable {

    //    IMPORTANT - please regenerate your serialVersionUID
    private static final long serialVersionUID = 5436766887639900902L;

    public GSSimStudioModel() {
    }
    
    private HashMap experimentsConfiguration = new HashMap();
    
    public HashMap getExperimentsConfiguration() {
        return experimentsConfiguration;
    }

    public void setExperimentsConfiguration(HashMap experimentsConfiguration) {
        this.experimentsConfiguration = experimentsConfiguration;
    }
    
    private HashMap comparisonComponents = new HashMap();
    
    public HashMap getComparisonComponents() {
        return comparisonComponents;
    }

    public void setComparisonComponents(HashMap comparisonComponents) {
        this.comparisonComponents = comparisonComponents;
    }
    
    private HashMap resourceChartComponents = new HashMap();
    
    public HashMap getResourceChartComponents() {
        return resourceChartComponents;
    }

    public void setResourceChartComponents(HashMap resourceChartComponents) {
        this.resourceChartComponents = resourceChartComponents;
    }
    
    private HashMap ganntChartComponents = new HashMap();
    
    public HashMap getGanntChartComponents() {
        return ganntChartComponents;
    }

    public void setGanntChartComponents(HashMap ganntChartComponents) {
        this.ganntChartComponents = ganntChartComponents;
    }
    
	/* FIELDS FOR GRMS3 HANDLING */
    public String errorDescription;
    public String grmsDN;
    public String grmsURL;
	/* END OF GRMS3 HANDLING */
	
	/* FIELDS FOR FILE TRANSFER */
	private ArrayList serverLocationItemList = new ArrayList();
	private HashMap currentLocationItem = new HashMap();
    private ArrayList linkLocationItemList = new ArrayList();
    private ArrayList workloadFileLocationItemList = new ArrayList();
    private ArrayList resourcesFileLocationItemList = new ArrayList();
    private ArrayList topologiesFileLocationItemList = new ArrayList();
	private int selectedServerIdx;
	/* END OF FILE TRANSFER */
	
	/* FIELDS FOR DB DATA */
	private String error;
	private byte[] currentExperimentNetworkTopology;
	private List<HashMap<String, String>> globalPluginList;
	private List<HashMap<String, String>> localPluginList;
	private List<Allocation> allocationList;
	private List<AllocationDetails> allocationDetailsList;
	private List<BlobProperty> blobPropertyList;
	private ExtendedConfiguration extendedConfiguration;
	private HashMap metaexperimentList = new HashMap();
	private List<Experiment> experimentList;
	private Boolean experimentListChanged = false;
	private List<ExperimentStats> experimentStatsList;
	private List<Queues> queuesList;
	private List<Reservation> reservationList;
	private List<ReservationDetails> reservationDetailsList;
	private List<Task> taskList;
	private List<TextProperty> textPropertyList;
	private List<Unit> unitList;
	private List<UnitAllTimeline> unitAllTimelineList;
	private List<UnitDetails> unitDetailsList;
	private List<UnitEnTimeline> unitEnTimelineList;
	private User user;
	/* END OF DB DATA */

    /**
	 * @return the grmsDN
	 */
	public String getGrmsDN() {
		return grmsDN;
	}

	/**
	 * @param grmsDN the grmsDN to set
	 */
	public void setGrmsDN(String grmsDN) {
		this.grmsDN = grmsDN;
	}

	/**
	 * @return the grmsURL
	 */
	public String getGrmsURL() {
		return grmsURL;
	}

	/**
	 * @param grmsURL the grmsURL to set
	 */
	public void setGrmsURL(String grmsURL) {
		this.grmsURL = grmsURL;
	}

	/**
	 * @return the errorDescription
	 */
	public String getErrorDescription() {
		return errorDescription;
	}

	/**
	 * @param errorDescription the errorDescription to set
	 */
	public void setErrorDescription(String errorDescription) {
		this.errorDescription = errorDescription;
	}
	
	public ArrayList getServerLocationItemList() {
        return serverLocationItemList;
    }

    public void setServerLocationItemList(ArrayList serverLocationItemList) {
        this.serverLocationItemList = serverLocationItemList;
    }
	
	public HashMap getCurrentLocationItem() {
        return currentLocationItem;
    }

    public void setCurrentLocationItem(HashMap currentLocationItem) {
        this.currentLocationItem = currentLocationItem;
    }

    public ArrayList getLinkLocationItemList() {
        return linkLocationItemList;
    }

    public void setLinkLocationItemList(ArrayList linkLocationItemList) {
        this.linkLocationItemList = linkLocationItemList;
    }
    
    public ArrayList getWorkloadFileLocationItemList(){
        return workloadFileLocationItemList;
    }

    public void setWorkloadFileLocationItemList(ArrayList fileLocationItemList){
        this.workloadFileLocationItemList=fileLocationItemList;
    }
    
    public ArrayList getTopologiesFileLocationItemList(){
        return topologiesFileLocationItemList;
    }

    public void setTopologiesFileLocationItemList(ArrayList fileLocationItemList){
        this.topologiesFileLocationItemList=fileLocationItemList;
    }
    
    public ArrayList getResourcesFileLocationItemList(){
        return resourcesFileLocationItemList;
    }

    public void setResourcesFileLocationItemList(ArrayList fileLocationItemList){
        this.resourcesFileLocationItemList=fileLocationItemList;
    }
	
	public int getSelectedServerIdx(){
        return selectedServerIdx;
    }

    public void setSelectedServerIdx(int selectedServerIdx){
        this.selectedServerIdx=selectedServerIdx;
    }
	
	public String getError() {
		return error;
	}

	public void setError(String error) {
		this.error = error;
	}
	
	public byte[] getCurrentExperimentNetworkTopology() {
		return currentExperimentNetworkTopology;
	}

	public void setCurrentExperimentNetworkTopology(byte[] currentExperimentNetworkTopology) {
		this.currentExperimentNetworkTopology = currentExperimentNetworkTopology;
	}
	
	public List<HashMap<String, String>> getGlobalPluginList() {
		return globalPluginList;
	}

	public void setGlobalPluginList(List<HashMap<String, String>> globalPluginList) {
		this.globalPluginList = globalPluginList;
	}
	
	public List<HashMap<String, String>> getLocalPluginList() {
		return localPluginList;
	}

	public void setLocalPluginList(List<HashMap<String, String>> localPluginList) {
		this.localPluginList = localPluginList;
	}
	
	public List<Allocation> getAllocationList() {
		return allocationList;
	}

	public void setAllocationList(List<Allocation> allocationList) {
		this.allocationList = allocationList;
	}

	public List<AllocationDetails> getAllocationDetailsList() {
		return allocationDetailsList;
	}

	public void setAllocationDetailsList(
			List<AllocationDetails> allocationDetailsList) {
		this.allocationDetailsList = allocationDetailsList;
	}

	public List<BlobProperty> getBlobPropertyList() {
		return blobPropertyList;
	}

	public void setBlobPropertyList(List<BlobProperty> blobPropertyList) {
		this.blobPropertyList = blobPropertyList;
	}

	public ExtendedConfiguration getExtendedConfiguration() {
		return extendedConfiguration;
	}

	public void setExtendedConfiguration(ExtendedConfiguration extendedConfiguration) {
		this.extendedConfiguration = extendedConfiguration;
	}

	public HashMap getMetaexperimentList() {
		return metaexperimentList;
	}

	public void setMetaexperimentList(HashMap metaexperimentList) {
		this.metaexperimentList = metaexperimentList;
	}
	
	public List<Experiment> getExperimentList() {
		return experimentList;
	}

	public void setExperimentList(List<Experiment> experimentList) {
		this.experimentList = experimentList;
	}
	
	public Boolean getExperimentListChanged() {
		return experimentListChanged;
	}

	public void setExperimentListChanged(Boolean experimentListChanged) {
		this.experimentListChanged = experimentListChanged;
	}

	public List<ExperimentStats> getExperimentStatsList() {
		return experimentStatsList;
	}

	public void setExperimentStatsList(List<ExperimentStats> experimentStatsList) {
		this.experimentStatsList = experimentStatsList;
	}

	public List<Queues> getQueuesList() {
		return queuesList;
	}

	public void setQueuesList(List<Queues> queuesList) {
		this.queuesList = queuesList;
	}

	public List<Reservation> getReservationList() {
		return reservationList;
	}

	public void setReservationList(List<Reservation> reservationList) {
		this.reservationList = reservationList;
	}

	public List<ReservationDetails> getReservationDetailsList() {
		return reservationDetailsList;
	}

	public void setReservationDetailsList(
			List<ReservationDetails> reservationDetailsList) {
		this.reservationDetailsList = reservationDetailsList;
	}

	public List<Task> getTaskList() {
		return taskList;
	}

	public void setTaskList(List<Task> taskList) {
		this.taskList = taskList;
	}

	public List<TextProperty> getTextPropertyList() {
		return textPropertyList;
	}

	public void setTextPropertyList(List<TextProperty> textPropertyList) {
		this.textPropertyList = textPropertyList;
	}

	public List<Unit> getUnitList() {
		return unitList;
	}

	public void setUnitList(List<Unit> unitList) {
		this.unitList = unitList;
	}

	public List<UnitAllTimeline> getUnitAllTimelineList() {
		return unitAllTimelineList;
	}

	public void setUnitAllTimelineList(List<UnitAllTimeline> unitAllTimelineList) {
		this.unitAllTimelineList = unitAllTimelineList;
	}

	public List<UnitDetails> getUnitDetailsList() {
		return unitDetailsList;
	}

	public void setUnitDetailsList(List<UnitDetails> unitDetailsList) {
		this.unitDetailsList = unitDetailsList;
	}

	public List<UnitEnTimeline> getUnitEnTimelineList() {
		return unitEnTimelineList;
	}

	public void setUnitEnTimelineList(List<UnitEnTimeline> unitEnTimelineList) {
		this.unitEnTimelineList = unitEnTimelineList;
	}

	public User getUser() {
		return user;
	}

	public void setUser(User user) {
		this.user = user;
	}
}